<?php
/* utf8-marker = äöüß */

/*
 * SEOCheck_XH
 *
 * @author Olaf Penschke
 * @version 1.1 (27.11.2019)
 
 * @license http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 
================================================================================
olape

================================================================================ 

*/

// Check if PLUGINLOADER is calling and die if not.

if(!defined('PLUGINLOADER'))
{
	die(
		'Plugin '. basename(dirname(__FILE__))
		. ' requires a newer version of the Pluginloader. No direct access.'
	);
}
//*********************************************************************************************
// dynamisches Menü unter Plugin

if (function_exists('XH_registerStandardPluginMenuItems'))
{
	XH_registerStandardPluginMenuItems(false);
}
//*********************************************************************************************
// zusätzlicher Menüpunkt im dynamischen Menü
XH_registerPluginMenuItem(
$plugin, 
$plugin_tx['seocheck']['backend_data'], 
'?&seocheck&admin=plugin_data&action=plugin_text&normal', 
''
);
//*********************************************************************************************
if(XH_wantsPluginAdministration('seocheck'))
{
	// zusätzliche Zeile und Tab im Adminmenü
	$o .= print_plugin_admin('on');
	pluginmenu('ROW');
	pluginmenu(
		'TAB', 
		'?&seocheck&admin=plugin_data&action=plugin_text&normal', 
		'', 
		XH_hsc($plugin_tx['seocheck']['backend_data'])
	);

	$o .= pluginmenu('SHOW');
//*********************************************************************************************
// Menü in der Pluginkopfzeile
	if(($admin != 'plugin_main') && ($admin != ''))
	{
		$o .= plugin_admin_common($action, $admin, $plugin);
	}
//*********************************************************************************************
//*********************************************************************************************
	$op_plugin_name = 'SEOCheck_XH';
	$op_plugin_version = '1.1';
	$op_copyright = '2017 - ' . date('Y');
	$op_cms_version_arr = array('1.6.10','1.7.0','1.7.1','1.7.2');
	$op_php_version = '5.3';
//*********************************************************************************************
//*********************************************************************************************

	if(($admin == '') || ($admin == 'plugin_main'))	//Anzeige nur auf Startseitedes Plugins und unter Info
	{
		$o .= '<div class="seocheckxh_admin">';
		/*$o .= "\n" . '<h1>'
		   . ucfirst(str_replace('_', ' ', $plugin)) . '</h1>';*/

		$o .= '<img class="seocheckxh_admin_logo" alt="Logo SEOCheck_XH" src="' . $pth['folder']['plugins'] . 'seocheck/img/logo-seocheck_xh-200.png">';
		$o .= "\n".'<h1>Plugin "' . $op_plugin_name . '" for CMSimple_XH</h1>
		<p>Version: ' . $op_plugin_version . '</p>
		<p>' . $op_plugin_name . ', Copyright © ' . $op_copyright . ' <a target="_blank" href="http://olaf.penschke.net/?CMSimple_XH/Plugins">Olaf Penschke</a></p>
		<p> </p>
		<p><a target="_blank" href="http://olaf.penschke.net/?Kontakt&xh_mailform_subject=' . $op_plugin_name . '">' . $plugin_tx['seocheck']['admin_contact'] . '</a></p>
		<p> </p>
		<p><b>' . $op_plugin_name . '</b> ' . $plugin_tx['seocheck']['admin_gplv3_1'] . ' <a target="_blank" href="https://www.gnu.org/licenses/gpl-3.0.de.html">GPLv3</a> ' . $plugin_tx['seocheck']['admin_gplv3_2'] . '</p>
		<hr>
		<p>Adapted for CMSimple_XH ' . $op_cms_version_arr[0] . ' - ' . end($op_cms_version_arr) . ' by <a target="_blank" href="http://www.cmsimple-xh.org/">cmsimple-xh.org</a></p>';

//*********************************************************************************************
// System check
//*********************************************************************************************
		$o .= '<h2>System Check</h2>';
// CMSimple_XH Version
		$op_cms_version_tmp = CMSIMPLE_XH_VERSION;
		$op_cms_version_tmp = str_replace(array('CMSimple_XH '), '', $op_cms_version_tmp);
		if(in_array($op_cms_version_tmp, $op_cms_version_arr, true))
		{
			$o .= '<p class="xh_success">' 
			   . CMSIMPLE_XH_VERSION 
			   . ' &#x2192 supported</p>' 
			   . "\n";
		}
		else
		{
			$o .= '<p class="xh_fail">' 
			   . CMSIMPLE_XH_VERSION 
			   . ' &#x2192 I hope it is still supported. It was designed for ' 
			   . $op_cms_version_arr[0] 
			   . ' - ' 
			   . end($op_cms_version_arr) 
			   . '.</p>' 
			   . "\n";
		}
// PHP Version
		if(version_compare(phpversion(), $op_php_version, '<'))
		{
			$o .= '<p class="xh_fail">PHP: ' 
			   . phpversion() 
			   . ' &#x2192 not supported</p>' 
			   . "\n";
		}
		else
		{
			$o .= '<p class="xh_success">PHP: ' 
			   . phpversion() 
			   . ' &#x2192 supported</p>' 
			   . "\n";
		}
// Schreibrechte
		$op_filename_arr = array($pth['folder']['plugins'] . 'seocheck/config/', 
								 $pth['folder']['plugins'] . 'seocheck/config/config.php', 
								 $pth['folder']['plugins'] . 'seocheck/css/', 
								 $pth['folder']['plugins'] . 'seocheck/css/stylesheet.css', 
								 $pth['folder']['plugins'] . 'seocheck/data/', 
								 $pth['folder']['plugins'] . 'seocheck/data/seocheck.dat', 
								 $pth['folder']['plugins'] . 'seocheck/data/userservice.dat', 
								 $pth['folder']['plugins'] . 'seocheck/languages/', 
								 $pth['folder']['plugins'] . 'seocheck/languages/' . $sl . '.php');
		foreach($op_filename_arr as $op_filename)
		{
			if(is_writable($op_filename))
			{
				$o .= '<p class="xh_success">' 
				   . $op_filename 
				   . ' &#x2192 writable</p>' 
				   . "\n";
			}
			else
			{
				$o .= '<p class="xh_fail>' 
				   . $op_filename 
				   . ' &#x2192 not writable</p>' 
				   . "\n";
			}
		}
		$o .= '</div>';
	}
//*********************************************************************************************
// Aufruf für das Speichern der seocheck.dat (Funktion save_seocheck_dat())

	if((isset($_POST['save'])) && ($_POST['save'] == 'seocheck_dat'))
	{
		$_POST['save'] = '';
		op_save_seocheck_dat('seocheck.dat');
	}

// Aufruf für das Speichern der userservice.dat (Funktion save_userservice_dat())

	if((isset($_POST['save'])) && ($_POST['save'] == 'userservice_dat'))
	{
		$_POST['save'] = '';
		op_save_userservice_dat('userservice.dat');
	}

//*********************************************************************************************
	if($admin == 'plugin_data')	//Anzeige unter data (bei de --> Dienste verwalten)
	{
// Aufruf für die Ausgaben der seocheck.dat (Funktion SEOCheckBackend())
		$o .= '<h2>' . $plugin_tx['seocheck']['form_h2'] . '</h2>';
		$o .= op_seocheckbackend('seocheck.dat');

// Aufruf für die Ausgaben der userservice.dat (Funktion UserServiceBackend())
		$o .= '<br><hr><br>';
		$o .= op_userservicebackend('userservice.dat');
	}

}
//*********************************************************************************************
// Zusätzlicher Tab über dem Editor

$pd_router->add_tab($plugin_tx['seocheck']['tab'], $pth['folder']['plugin'] . 'seocheck.php');

//*********************************************************************************************
// Formular zum Anzeigen der seocheck.dat

function op_seocheckbackend($op_service_dat_tmp = '')
{
	global $pth, $sn, $plugin_tx;

	$op_backend_html = '<form class="sc_form" method="post" action="'. $sn . '?seocheck&admin=plugin_data">';
	$op_backend_html .= '<input readonly type="hidden" name="save"value="seocheck_dat">' . "\n";
	$op_backend_html .= '<table>' . "\n";

	$op_service_dat = file($pth['folder']['plugins'] . 'seocheck/data/' . $op_service_dat_tmp);
	for($i=0; $i < count($op_service_dat); $i++)
	{
		$op_backend_html .= '<tr>' . "\n";
		$op_service_array = explode(',', $op_service_dat[$i]);
		$op_backend_html .= '<td><input class="sc_form_text" readonly type="text" name="'. $i . '_service" size="20" maxlength="20" value="' . $op_service_array[0] . '"></td>' . "\n";
		$op_backend_html .= '<td><input class="sc_form_text" readonly type="text" name="'. $i . '_url" size="30" maxlength="30" value="' . $op_service_array[1] . '"></td>' . "\n";
		$op_backend_html .= '<td><input class="sc_form_text" readonly type="text" name="'. $i . '_protocol" size="12" maxlength="12" value="' . $op_service_array[2] . '"></td>' . "\n";
		if(!isset($op_service_array[3]))
		{
			$op_service_array[3] = 'on';
		}
		if($op_service_array[3] != 'off')
		{
			$op_backend_html .= '<td><input class="sc_form_check" type="checkbox" name="'. $i . '_on_off" value="on" checked="checked"></td>' . "\n";
		}
		else
		{
			$op_backend_html .= '<td><input class="sc_form_check" type="checkbox" name="'. $i . '_on_off" value="off"></td>' . "\n";
		}
		$op_backend_html .= '</tr>' . "\n";
	}

	$op_backend_html .= '</table>' . "\n";
	$op_backend_html .= '<input readonly type="hidden" name="anz_datensaetze" size="3" maxlength="3" value="' . $i . '">' . "\n";
	$op_backend_html .= '<input class="sc_form_submit" type="submit" value="' . $plugin_tx['seocheck']['form_save'] . '">' . "\n";
	$op_backend_html .= '</form>' . "\n";

	return $op_backend_html;
}

//*********************************************************************************************
// Formular zum Anzeigen der userservice.dat

function op_userservicebackend($op_service_dat_tmp = '')
{
	global $pth, $sn, $plugin_tx;

	$op_backend_html = $plugin_tx['seocheck']['form_note'] . '<br>';
	$op_backend_html .= $plugin_tx['seocheck']['form_example'] . 'WooRank,https://www.woorank.com/de/www/,protocol_off,on,' . '<br>' . '<br>';

	$op_backend_html .= '<form class="sc_form" method="post" action="'. $sn . '?seocheck&admin=plugin_data">';
	$op_backend_html .= '<input readonly type="hidden" name="save"value="userservice_dat">' . "\n";

	$op_service_dat = file_get_contents($pth['folder']['plugins'] . 'seocheck/data/userservice.dat');
	$op_backend_html .= '<textarea class="sc_form_textarea" name="userservice_dat" cols="56" rows="10">' . $op_service_dat . '</textarea>';
	$op_backend_html .= '<br>' . "\n";
	$op_backend_html .= '<input class="sc_form_submit" type="submit" value="' . $plugin_tx['seocheck']['form_save'] . '">' . "\n";
	$op_backend_html .= '</form>' . "\n";

	return $op_backend_html;
}

//*********************************************************************************************
// Speichern der seocheck.dat

function op_save_seocheck_dat($op_dat = '')
{
	global $o, $plugin_tx;

	$j = 0;
	if(isset($_POST['anz_datensaetze']))
	{
		$j = $_POST['anz_datensaetze'] + 0;
	}

	$datafile = __DIR__ . '/data/' . $op_dat;
	$datafile_tmp = __DIR__ . '/data/' . $op_dat . '.tmp';
	$datapth = __DIR__ . '/data/';

	if((is_writable($datapth)) && ($j > 0))
	{
		$op_service_file = fopen($datafile_tmp, 'w');
		$k = 0;  
		while($k < $j)
		{
			$op_out_tmp = '';
			$op_out_tmp .= isset($_POST[($k . '_service')]) ? $_POST[($k . '_service')] . ',' : ',';
			$op_out_tmp .= isset($_POST[($k . '_url')]) ? $_POST[($k . '_url')] . ',' : ',';
			$op_out_tmp .= isset($_POST[($k . '_protocol')]) ? $_POST[($k . '_protocol')] . ',' : ',';
			$op_out_tmp .= isset($_POST[($k . '_on_off')]) ? utf8_encode('on,') : utf8_encode('off,');
			
			fputs($op_service_file, $op_out_tmp . "\n");
			$k++;
		}
		fclose($op_service_file);
		if(file_exists($datafile . '.bak'))
		{
			unlink($datafile . '.bak');
		}
		rename($datafile, $datafile . '.bak');
		rename($datafile_tmp, $datafile);
		$o .= '<br>';
		$o .= '<div class="xh_success">' . $plugin_tx['seocheck']['has_save'] . '</div>';
	}
}

//*********************************************************************************************
// Speichern der userservice.dat

function op_save_userservice_dat($op_dat = '')
{
	global $o, $plugin_tx;

	$datafile = __DIR__ . '/data/' . $op_dat;
	$datafile_tmp = __DIR__ . '/data/' . $op_dat . '.tmp';
	$datapth = __DIR__ . '/data/';

	if((is_writable($datapth)) && ($_POST['userservice_dat'] != ''))
	{
		$op_service_file = fopen($datafile_tmp, 'w');
		$op_out_tmp = utf8_encode($_POST['userservice_dat']);
		fputs($op_service_file, $op_out_tmp);
		fclose($op_service_file);
		if(file_exists($datafile . '.bak'))
		{
			unlink($datafile . '.bak');
		}
		rename($datafile, $datafile . '.bak');
		rename($datafile_tmp, $datafile);
		$o .= '<br>';
		$o .= '<div class="xh_success">' . $plugin_tx['seocheck']['has_save'] . '</div>';
	}
}
//*********************************************************************************************

?>