<?php
/* utf8-marker = äöüß */

/*
 * SEOCheck_XH
 *
 * @author Olaf Penschke
 * @version 1.1 (27.11.2019)
 
 * @license http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 
================================================================================
olape

================================================================================ 

*/

if('seocheck.php' == basename($_SERVER['SCRIPT_FILENAME']))
{
	die('No direct access.');
}

include_once (__DIR__ . '/config/config.php');

function SEOCheck ()
{
	global $pth, $su, $plugin_cf;

	$op_seocheck_url_array = parse_url(CMSIMPLE_URL);																		// 'scheme' => 'http', 'host' => 'test.domain.tld', 'path' => /unterordner/, 'query' => 'Welcome-to-CMSimple_XH',
	if(!empty($plugin_cf['seocheck']['userservice_enable']))
	{ 
		$op_service_dat_array = array('seocheck.dat', 'userservice.dat');													// seocheck.dat kann/wird bei Updates überschrieben, userservice.dat bleibt bestehen
	}
	else
	{
		$op_service_dat_array = array('seocheck.dat');
	}

	$op_html = '<b>SEOCheck: ' . CMSIMPLE_URL . (($su != '') ? ('?' . $su) : ('')) . '</b>';
	$op_html .= '<br>';

	foreach ($op_service_dat_array as $op_service_dat_tmp)
	{
		$op_html .= '<ul class="sc_tab_list">';
		$op_service_dat = file($pth['folder']['plugins'] . 'seocheck/data/' . $op_service_dat_tmp);
		for($i=0; $i < count($op_service_dat); $i++)
		{
			$op_service_array = explode(',', $op_service_dat[$i]);
			if($op_service_array[3] != 'off')																				// ist Dienst deaktiviert? (on/off in seocheck.dat)
			{
				$op_html .= '<li>&#x2794 <a target="_blank" href="' 
						 . $op_service_array[1] 
						 . (($op_service_array[2] == 'protocol_on') ? ($op_seocheck_url_array['scheme'] . '://') : ('')) 	// soll Protokoll (http(s)) übergeben werden
						 . $op_seocheck_url_array['host'] 
						 . $op_seocheck_url_array['path'] 
						 . (($su != '') ? ('?' . $su) : ('')) 
						 . '">' 
						 . $op_service_array[0] 
						 . '</a></li>';
			}
		}
		$op_html .= '</ul>';
	}

	return $op_html;
}
?>
